#pragma once
#include "afxwin.h"
#include "NoteModel.h"
#include "EditBytes.h"
#include "WndSMSRecvList.h"
#include "SkinDialog.h"
#include "SMSController.h"
#include "SMSDropTarget.h"
#include "EditPhoneNumber.h"

#define DEF_SMS_DLG_SIZE_CX				400
#define DEF_SMS_DLG_SIZE_CY				350
#define SMS_DLG_CONTROL_BORDER_COLOR	RGB(198,202,205)
#define SMS_DLG_BORDER_PIXEL			1
#define SMS_DLG_TEXT_BG_COLOR			RGB(34,34,34)
#define SMS_DLG_BG_COLOR				RGB(255,255,255)
#define SMS_DLG_EDIT_FONT_COLOR			RGB(136,136,136)
#define MAXSMSRECEIVER					50

#define ID_RECV_LIST					(0xE370)

class CSMSSendDlg : public CDialog ,	IGTWASActorEvent, IGTMessengerActorEvent
{
	DECLARE_DYNAMIC(CSMSSendDlg)

public:
	CSMSSendDlg(CWnd* pParent = NULL);   // ǥ Դϴ.
	virtual ~CSMSSendDlg();

// ȭ  Դϴ.
	enum { IDD = IDD_SMS_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.
	virtual void PostNcDestroy();

	DECLARE_MESSAGE_MAP()
public:

	virtual BOOL OnInitDialog();


	virtual BOOL PreTranslateMessage(MSG* pMsg);
	BOOL Create(const std::vector<CSMSModel::SMSReceiverInfo>& receiverVector, UINT nIDTemplate,CWnd* pParentWnd/* =NULL */);

	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnBnClickedButtonSend();
	afx_msg void OnBnClickedButtonCancel();
	void __ResourceLoad(BOOL bInit = FALSE);
	CString m_strSMSLength;

private:
	CWndSMSRecvList m_wndRecvList;
	CEditBytes m_edContent;
	CEditPhoneNumber m_edSender;
	CButton m_btnSend;
	CButton m_btnCancel;
	void InitSkin();
	CRect m_rcRecveierText;
	CRect m_rcRecveierLimitText;
	CRect m_rcSenderText;
	CRect m_rcByteCheckText;
	CRect m_rcContent;
	CRect m_rcSMSlength;
	bool m_bShowContentEdit;
	SMSDropTarget *m_pDropTarget;

	void SetDragAndDrop();
	void AddSMSReceiver(); 
	
	std::vector<CSMSModel::SMSReceiverInfo> m_receiverVector;
	bool				m_bInitializeSuccess;
	static void OnEventContent(int nID, int nBytes, void* pUser);
	static void OnEventPhoneNumber(int nID, void* pUser);
	bool IsCloseMsg( MSG* pMsg );
	CSMSController *m_pSMSController;
	virtual bool OnGTWASActor_ResponseSMS(IGTWASActor *pActor, 	trid_t trid, 	GTWASCallErrorCode eErrorCode, 	const NE_SMS_DATA &smsCount	); 
public:
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnNcDestroy();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg LRESULT		OnReciverListDelUser(WPARAM wParam, LPARAM lParam);
	afx_msg LRESULT		OnReciverListUserInfo(WPARAM wParam, LPARAM lParam);
	void CloseSMSDialog();

	std::list<trid_t>	m_tridList;
	CEditPhoneNumber m_edAddPhoneNumber;
	CButton m_btnAddPhoneNumber;
	afx_msg void OnBnClickedButtonAddPhone();
	CButton m_btnClose;
	afx_msg void OnBnClickedButtonClose();
};